// *********************************************************
//
// agent1.cc      : Test agent #1 Main File
// author         : Fabio Silva
//
// $Id: agent1.cc,v 1.3 2000/10/18 00:28:02 fabio Exp $
//
// *********************************************************

#include "agent.hh"
MyReceive *mr;

NRSimpleAttributeFactory<char *> TargetAttr(NRAttribute::TARGET_KEY, NRAttribute::STRING_TYPE);
NRSimpleAttributeFactory<int> AppDummyAttr(APP_KEY1, NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> AppCounterAttr(APP_KEY3, NRAttribute::INT32_TYPE);

void MyReceive::recv(NRAttrVec *data, NR::handle my_handle)
{
   NRSimpleAttribute<int> *counterAttr = NULL;

   counterAttr = AppCounterAttr.find(data);

   if (!counterAttr){
      printf("Received a BAD packet !\n");
      printAttrs(data);
      return;
   }

   printf("Received data %d !\n", counterAttr->getVal());
}

handle setupInterest(NR *dr)
{
   NRAttrVec attrs;

   attrs.push_back(NRClassAttr.make(NRAttribute::IS, NRAttribute::INTEREST_CLASS));
   attrs.push_back(LatitudeAttr.make(NRAttribute::GT, 54.78));
   attrs.push_back(LongitudeAttr.make(NRAttribute::LE, 87.32));
   attrs.push_back(TargetAttr.make(NRAttribute::IS, "F117A"));
   attrs.push_back(AppDummyAttr.make(NRAttribute::IS, 2001));

   handle h = dr->subscribe(&attrs, mr);

   ClearAttrs(&attrs);

   return h;
}

void main()
{
   NR *dr;
   handle subHandle;

   dr = NR::createNR();
   mr = new MyReceive;
   
   subHandle = setupInterest(dr);
   
   while (1){
      char input;

      printf("Now what ? ");
      input = getc(stdin);

      if (input == 'c'){
         dr->unsubscribe(subHandle);
         exit(0);
      }
   }
}
