// *********************************************************
//
// attrs.hh        : Attribute Functions Definitions
// authors         : John Heidemann and Fabio Silva
//
// $Id: attrs.hh,v 1.4 2000/10/02 23:43:31 fabio Exp $
//
// *********************************************************

#ifndef ATTRS_HH
#define ATTRS_HH

#include "netinet/in.h"
#include "nr.hh"
#include "header.hh"

int CalculateSize(NRAttrVec *attr_vec);
int PackAttrs(NRAttrVec *attr_vec, char *start_pos);
NRAttrVec * CopyAttrs(NRAttrVec *src_attrs);
NRAttrVec * UnpackAttrs(Packet pkt, int num_attr);
void ClearAttrs(NRAttrVec *attr_vec);
bool PerfectMatch(NRAttrVec *attr_vec1, NRAttrVec *attr_vec2);
bool OneWayPerfectMatch(NRAttrVec *attr_vec1, NRAttrVec *attr_vec2);
bool MatchAttrs(NRAttrVec *attr_vec1, NRAttrVec *attr_vec2);
bool OneWayMatch(NRAttrVec *attr_vec1, NRAttrVec *attr_vec2);
void printAttrs(NRAttrVec *attr_vec);

#endif
