// *********************************************************
//
// dgram.h       : Socket support
// authors       : Chalermek Intanagonwiwat and Fabio Silva
//
// $Id: dgram.hh,v 1.3 2001/03/20 23:02:20 fabio Exp $
//
// *********************************************************

#ifndef dgram_hh
#define dgram_hh

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

#define SKT_FD(x)      (x)->skt_fd
#define SKT_ADDR(x)    (x)->skt_addr_inet

#define HDR_DIFF(x)   (struct hdr_diff *)(x)
#define SZ_ADDR_INET   sizeof(struct sockaddr_in)

#define SEND_TO(x,y)   sendto(SKT_FD(x), y, sizeof(struct hdr_diff) \
			      + ntohs(DATA_LEN(HDR_DIFF(y))), 0, \
	                      (struct sockaddr *)&SKT_ADDR(x), \
                              sizeof(SKT_ADDR(x)) )

#define RECV_FROM(x,y,z)   recvfrom(SKT_FD(x), y, sizeof(struct hdr_diff), \
                              MSG_PEEK, (struct sockaddr *)&SKT_ADDR(x), &z); \
                           recvfrom(SKT_FD(x), y, sizeof(struct hdr_diff)+ \
			      ntohs(DATA_LEN(HDR_DIFF(y))), 0, \
			      (struct sockaddr *)&SKT_ADDR(x), &z)


struct socket_info{
  int skt_fd;                          // socket file descriptor
  struct sockaddr_in skt_addr_inet;    // socket address internet
};

struct hostent * GetThisHostEnt();
struct hostent * GetThisHostEntWired();
struct socket_info * CreateSocket(struct hostent *h_entPtr, u_int16_t port);
void RegisterSocket(struct socket_info *skt_info);
struct socket_info * OpenIncomingSocket(u_int16_t port);
#endif
