// *********************************************************
// 
// filter.hh     : Filter definitions
// authors       : Fabio Silva
//
// $Id: filter.hh,v 1.4 2001/03/23 20:56:31 fabio Exp $
//
// *********************************************************

#ifndef filter_hh
#define filter_hh

#include <sys/time.h>
#include <unistd.h>

#include "message.hh"
#include "dgram.hh"

#include <list>

class Filter_Entry;
class FilterCallback;

typedef list<Filter_Entry *> FilterList;
typedef long handle;

class Filter_Entry {
public:
  NRAttrVec          *filterAttrs;
  int16_t            handle;
  u_int16_t          priority;
  u_int16_t          agent;
  struct socket_info *skt_info;
  FilterCallback     *cb;
  struct timeval     tmv;
  bool               valid;
   
  Filter_Entry(int16_t _handle, u_int16_t _priority, u_int16_t _agent) : handle(_handle), priority(_priority), agent(_agent)
  {
    skt_info = NULL;
    valid = true;
    cb = NULL;
    gettimeofday(&tmv, NULL);
  }

  ~Filter_Entry() {
    
    if (skt_info)
      delete skt_info;

    if (filterAttrs){
      ClearAttrs(filterAttrs);
      delete filterAttrs;
    }
  }
};

class FilterCallback {
public:
  virtual void recv(Message *msg, handle h) = 0;
};

#endif
