// *********************************************************
// 
// message.cc    : Message and Filters' factories
// authors       : Fabio Silva
//
// $Id: message.cc,v 1.10 2000/12/18 19:30:23 fabio Exp $
//
// *********************************************************

#include "message.hh"

NRSimpleAttributeFactory<void *> ControlMsgAttr(CONTROL_MESSAGE_KEY, NRAttribute::BLOB_TYPE);
NRSimpleAttributeFactory<void *> OriginalHdrAttr(ORIGINAL_HEADER_KEY, NRAttribute::BLOB_TYPE);
NRSimpleAttributeFactory<int> NRScopeAttr(NRAttribute::SCOPE_KEY, NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<int> NRClassAttr(NRAttribute::CLASS_KEY, NRAttribute::INT32_TYPE);
NRSimpleAttributeFactory<void *> ReinforcementAttr(REINFORCEMENT_KEY, NRAttribute::BLOB_TYPE);

Message * CopyMessage(Message *msg)
{
   Message *newMsg;

   newMsg = new Message(msg->version, msg->msg_type, msg->source_port,
			msg->data_len, msg->num_attr, msg->pkt_num,
			msg->rdm_id, msg->next_hop, msg->last_hop);

   newMsg->new_message = msg->new_message;
   newMsg->msg_attr_vec = CopyAttrs(msg->msg_attr_vec);

   // We currently don't use the original message packet
   // So the following lines were commented to avoid allocating/
   // dealocating memory all the time

   // newMsg->msg_size = msg->msg_size;
   // newMsg->msg = new int [(msg->msg_size / sizeof(int)) + 1];
   // memcpy(newMsg->msg, msg->msg, msg->msg_size);

   return newMsg;
}
