// *********************************************************
//
// replicator.hh : Wired Support Include File
// Authors       : Chalermek Intanagonwiwat and Fabio Silva
//
// $Id: replicator.hh,v 1.3 2000/11/01 18:35:05 fabio Exp $
//
// *********************************************************

#ifndef replicator_hh
#define replicator_hh

#define RELIABLE_LINK 100

#include <list>

class Topology_Entry {
public:
  Topology_Entry(){
    skt = NULL;
    quality = 100;
  };

  ~Topology_Entry(){
    delete skt;
  };

  struct socket_info *skt;
  int quality;
};

typedef list<Topology_Entry *> TopologyList;

class DiffusionWired {
public:
  DiffusionWired(char *config_file);
  void send(void *pkt, int len);

protected:
  int num_neighbors;
  TopologyList neighbors_list;
};

#endif
